unit pcinfo;

interface

uses
    Windows, Classes, SysUtils, Registry, ShellApi;

function GetOsInfo(): string;
function GetWindowsProductID(): string;

function GetIEVersion(): string;
function GetIEVersion2(): string;
function GetIEUpdate(): string;

function GetScreenAbility(): string;
function GetMemoryStatus(var Phys, Page, Virt: string): string;
function GetDriveStatus(): string;

implementation

uses
    util;

//  ===========================================================================
//  EBhEỸo[W擾
//  http://www.geocities.jp/ht_deko/ft0203.html
//  http://plaza5.mbn.or.jp/~heropa/vb25.htm
//  ===========================================================================
const
    VER_NT_WORKSTATION       = 1;
    VER_NT_DOMAIN_CONTROLLER = 2;
    VER_NT_SERVER            = 3;
    VER_SUITE_SMALLBUSINESS            = $0001;
    VER_SUITE_ENTERPRISE               = $0002;
    VER_SUITE_BACKOFFICE               = $0004;
    VER_SUITE_TERMINAL                 = $0010;
    VER_SUITE_SMALLBUSINESS_RESTRICTED = $0020;
    VER_SUITE_DATACENTER               = $0080;
    VER_SUITE_PERSONAL                 = $0200;
    VER_SUITE_BLADE                    = $0400;

function GetOsInfo(): string;
var
    osvi:TOSVersionInfoEx;
    res : Boolean;
    Key: HKEY;
    szProductType: string;
    dwBufLen, dwTemp: DWORD;
    lRet: integer;
begin
    Result := 'Unknown';

    // OSVERSIONINFOEX  GetVersionEx Ă݂ 
    // s OSVERSIONINFO łĂ݂ 

    // 
    FillChar(osvi, SizeOf(TOSVersionInfoEx), #0);

    // \̃TCYZbg
    osvi.dwOSVersionInfoSize := SizeOf(TOSVersionInfoEx);

    // Ă݂
    res := GetVersionEx(osvi);

    // s
    if not res then
    begin
        // ЂƂ̍\̂
        osvi.dwOSVersionInfoSize := SizeOf(TOSVersionInfo);
        // ߂Ȃ炠߂
        if not GetVersionEx(osvi) then Exit;
    end;

    // dwPlatformId ŌɂȂقǏꍇ킯
    case osvi.dwPlatformId of

    // Windows NT n.
    VER_PLATFORM_WIN32_NT:
        begin

            // Ɠ肵Ă݂
            if (osvi.dwMajorVersion = 5) and (osvi.dwMinorVersion = 2) then
            begin
                Result := 'Microsoft Windows .NET Server 2003 family, ';
            end else
            if (osvi.dwMajorVersion = 5) and (osvi.dwMinorVersion = 1) then
            begin
                Result := 'Microsoft Windows XP ';
            end else
            if (osvi.dwMajorVersion = 5) and (osvi.dwMinorVersion = 0) then
            begin
                Result := 'Microsoft Windows 2000 ';
            end else
            begin
            if (osvi.dwMajorVersion <= 4) then
            begin
                Result := 'Microsoft Windows NT ';
            end else
                Result := 'Windows NT product family? ';
            end;

            // Windows NT 4.0 SP6 ȍ~Ɠ˂Œׂ.
            if res then
            begin

                // workstation ^Cv
                if (osvi.wProductType = VER_NT_WORKSTATION) then
                begin
                    if (osvi.dwMajorVersion = 4) then
                    begin
                        Result := Result + 'Workstation 4.0 ';
                    end else
                    if (osvi.wSuiteMask and VER_SUITE_PERSONAL) = VER_SUITE_PERSONAL then
                    begin
                        Result := Result + 'Home Edition ';
                    end else
                    begin
                        Result := Result + 'Professional ';
                    end;
                end else

                // server ^Cv
                if (osvi.wProductType = VER_NT_SERVER) then
                begin
                    if (osvi.dwMajorVersion = 5) and (osvi.dwMinorVersion = 2) then
                    begin
                        if (osvi.wSuiteMask and VER_SUITE_DATACENTER) = VER_SUITE_DATACENTER then
                        begin
                            Result := Result + 'Datacenter Edition ';
                        end else
                        if (osvi.wSuiteMask and VER_SUITE_ENTERPRISE) = VER_SUITE_ENTERPRISE then
                        begin
                            Result := Result + 'Enterprise Edition ';
                        end else
                        if (osvi.wSuiteMask = VER_SUITE_BLADE) then
                        begin
                            Result := Result + 'Web Edition ';
                        end else
                        begin
                            Result := Result + 'Standard Edition ';
                        end;
                    end else
                    if (osvi.dwMajorVersion = 5) and (osvi.dwMinorVersion = 0) then
                    begin
                        if (osvi.wSuiteMask and VER_SUITE_DATACENTER) = VER_SUITE_DATACENTER then
                        begin
                            Result := Result + 'Datacenter Server ';
                        end else
                        if (osvi.wSuiteMask and VER_SUITE_ENTERPRISE) = VER_SUITE_ENTERPRISE then
                        begin
                            Result := Result + 'Advanced Server ';
                        end else
                        begin
                            Result := Result + 'Server ';
                        end;
                    end else
                    // Windows NT 4.0
                    begin
                        if (osvi.wSuiteMask and VER_SUITE_ENTERPRISE) = VER_SUITE_ENTERPRISE then
                        begin
                            Result := Result + 'Server 4.0, Enterprise Edition ';
                        end else
                        begin
                            Result := Result + 'Server 4.0 ';
                        end;
                    end;
                end;

            end else
            // Windows NT 4.0 SP5 ȑÔ
            begin
                lRet := RegOpenKeyEx(
                            HKEY_LOCAL_MACHINE,
                            'SYSTEM\CurrentControlSet\Control\ProductOptions',
                            0,
                            KEY_QUERY_VALUE,
                            Key
                        );
                if lRet <> ERROR_SUCCESS then Exit;

                dwBufLen := 255;
                szProductType := '';
                SetLength(szProductType, dwBufLen);

                lRet := RegQueryValueEx(
                            Key,
                            'ProductType',
                            nil,
                            nil,
                            @szProductType[1],
                            @dwBufLen
                        );
                if (lRet <> ERROR_SUCCESS) then Exit;
                dwTemp := Length(szProductType);
                if (dwBufLen > dwTemp) then Exit;
                SetLength(szProductType, dwBufLen);

                RegCloseKey(Key);

                if UpperCase(szProductType) = 'WINNT' then
                begin
                    Result := Result + 'Workstation ';
                end else
                if UpperCase(szProductType) = 'LANMANNT' then
                begin
                    Result := Result + 'Server ';
                end else
                if UpperCase(szProductType) = 'SERVERNT' then
                begin
                    Result := Result + 'Advanced Server ';
                end;

                Result := Result + Format('%d.%d', [osvi.dwMajorVersion, osvi.dwMinorVersion]);
            end;

            // T[rXpbNƂrhԍƂ

            if (osvi.dwMajorVersion = 4) and (lstrcmpi( osvi.szCSDVersion, 'Service Pack 6' ) = 0 ) then
            begin
                // SP6 ? SP6a?

                lRet := RegOpenKeyEx(
                            HKEY_LOCAL_MACHINE,
                            'SOFTWARE\Microsoft\Windows NT\CurrentVersion\Hotfix\Q246009',
                            0,
                            KEY_QUERY_VALUE,
                            Key
                        );
                if (lRet = ERROR_SUCCESS) then
                begin
                    Result := Result + Format('Service Pack 6a (Build %d)', [osvi.dwBuildNumber and $FFFF]);
                end else

                // Windows NT 4.0 prior to SP6a
                begin
                    Result := Result + Format('%s (Build %d)', [osvi.szCSDVersion, osvi.dwBuildNumber and $FFFF]);
                end;
                RegCloseKey(Key);
            end else

            // Windows NT 3.51 and earlier or Windows 2000 and later
            begin
                Result := Result + Format('%s (Build %d)', [osvi.szCSDVersion, osvi.dwBuildNumber and $FFFF]);
            end;

        end;

    // Windows 95 n.
    VER_PLATFORM_WIN32_WINDOWS:
        begin
            // win95
            if (osvi.dwMajorVersion = 4) and (osvi.dwMinorVersion = 0) then
            begin
                Result := 'Microsoft Windows 95 ';
                if (osvi.szCSDVersion[1] = 'C') or (osvi.szCSDVersion[1] = 'B') then
                begin
                    Result := Result + 'OSR2 ';
                end;
            end else
            // win98
            if (osvi.dwMajorVersion = 4) and (osvi.dwMinorVersion = 10) then
            begin
                Result := 'Microsoft Windows 98 ';
                if ( osvi.szCSDVersion[1] = 'A') then
                begin
                    Result := Result + 'SE ';
                end;
            end else
            // winme
            if (osvi.dwMajorVersion = 4) and (osvi.dwMinorVersion = 90) then
            begin
                Result := 'Microsoft Windows Millennium Edition';
            end;
        end;

    // ȊO
    VER_PLATFORM_WIN32s:
        begin
            Result := 'Microsoft Win32s';
        end;

    end;

end;

//  ===========================================================================
//  Windows ̃v_NgID擾
//  http://www.ruriplus.com/msaccess/tch/tch_036.html
//  http://homepage1.nifty.com/MADIA/delphi/delphi_bbs/200302_03020032.html
//  ===========================================================================
function GetWindowsProductID(): string;
const
    KEY_READ = ((STANDARD_RIGHTS_READ or KEY_QUERY_VALUE or KEY_ENUMERATE_SUB_KEYS
                 or KEY_NOTIFY) and (not SYNCHRONIZE));
var
    OSVER: TOSVersionInfo;
    SubKey: string;
    KeyRoot: HKEY;
    buf: PBYTE;
    dwType, dwLen: DWORD;
begin
    Result := '';
    //  
    FillChar(OSVER, SizeOf(OSVER), #0);
    //  TCYݒ
    OSVER.dwOSVersionInfoSize := SizeOf(OSVER);
    //  o[W擾(sŏI)
    if not Windows.GetVersionEx(OSVER) then exit;
    //  NTn̏ꍇ
    if OSVER.dwPlatformId = VER_PLATFORM_WIN32_NT then
    begin
        //  TuL[ݒ
        SubKey := 'SOFTWARE\Microsoft\Windows NT\CurrentVersion';
    end
    //  łȂꍇ
    else
    begin
        //  TuL[ݒ
        SubKey := 'SOFTWARE\Microsoft\Windows\CurrentVersion';
    end;
    //  WXgĂ݂(sŏI)
    if RegOpenKeyEx(HKEY_LOCAL_MACHINE, PChar(SubKey), 0, KEY_READ, KeyRoot) <> 0 then exit;
    //  m
    buf := GetMemory(255);
    //  mۂݒ
    dwLen := 255;
    //  l̃^Cvݒ
    dwType := REG_SZ;
    //  Gglo
    RegQueryValueEx(KeyRoot, 'ProductId', nil, @dwType, PBYTE(buf), @dwLen);
    //  ɕϊ
    Result := string(PChar(buf));
    //  
    FreeMemory(buf);
    //  WXg߂
    RegCloseKey(KeyRoot);
end;

//  ===========================================================================
//  IẼo[W擾
//  http://support.microsoft.com/kb/164539/JA/
//  ===========================================================================
function GetIEVersion(): string;
const
    IE_KEY = 'Software\Microsoft\Internet Explorer';
var
    Reg: TRegistry;
    StrBuf: TStringList;
    index: integer;
    IVer, Build: string;
begin
    Result := '';
    Reg := TRegistry.Create;
    try
        StrBuf := TStringList.Create;
        try
            //  [gL[ݒ肵
            Reg.RootKey := HKEY_LOCAL_MACHINE;
            //  ǂ̃L[J(ȂꍇɍȂ悤)
            if Reg.OpenKey(IE_KEY, false) then
            begin
                //  쐬ĂL[̈ꗗ擾
                Reg.GetValueNames(StrBuf);
                //  \[g
                StrBuf.Sorted := true;

                //  Internet Explorer 4.0 ȍ~
                if (StrBuf.Find('Version', index)) then
                begin
                    Result := Reg.ReadString(StrBuf[index]);
                end
                //  'IVer'Ŕ(Ȃ̂H)
                else if (StrBuf.Find('IVer', index)) then
                begin
                    IVer := Reg.ReadString(StrBuf[index]);
                    Build := Reg.ReadString('Build');

                    //  Internet Explorer 3.x Ȃ
                    if (IVer = '103') then
                    begin
                        Result := 'Internet Explorer 3.x.' + Build;
                    end
                    else if (IVer = '102') then
                    begin
                        Result := 'Internet Explorer 2.0 for Windows 95 Build ' + Build;
                    end
                    else if (IVer = '101') then
                    begin
                        Result := 'Windows NT 4.0 Ɋ܂܂ Internet Explorer';
                    end
                    else if (IVer = '100') then
                    begin
                        Result := 'Internet Explorer 1.0 for Windows 95';
                    end;
                end
                else
                begin
                    //  R͂肦Ȃ悤ɓǂ߂
                end;
            end;
        finally
            StrBuf.Free;
        end;
    finally
        Reg.Free;
    end;
end;

//  ===========================================================================
//  IẼo[W擾
//  http://support.microsoft.com/kb/164539/JA/
//  ===========================================================================
function GetIEVersion2(): string;
const
    QX_DIR = 'system';
    NT_DIR = 'system32';
    IE_DLL = 'Shdocvw.dll';
var
    DllVerTable, ExeVerTable: TStringList;
    WinDir: string;
    DllPath: string;
    index, i: integer;

    procedure MakeTable(const DllVer, ExeVer: string);
    begin
        DllVerTable.Add(DllVer);
        ExeVerTable.Add(ExeVer);
    end;

begin
    Result := '';

    //  WindowsfBNg擾
    WinDir := GetWindowsDirectory();

    //  Windows 95AWindows 98A Windows Me ̏ꍇƉ
    DllPath := IncludeTrailingPathDelimiter(WinDir) + QX_DIR + '\' + IE_DLL;
    if (not FileExists(DllPath)) then
    begin
        //  Windows NT 4.0AWindows 2000AWindows XPAWindows Server 2003 炵
        DllPath := IncludeTrailingPathDelimiter(WinDir) + NT_DIR + '\' + IE_DLL;
        if (not FileExists(DllPath)) then
        begin
            //  IE
            exit;
        end;
    end;

    //  DLL̃o[W𒲂ׂ
    Result := GetFileVersion(DllPath);

    //  DLLo[WIEo[WĂe[u쐬
    DllVerTable := TStringList.Create();
    ExeVerTable := TStringList.Create();
    try
        MakeTable('4.70.1155','Internet Explorer 3.0');
        MakeTable('4.70.1158','Internet Explorer 3.0 (Windows 95 OSR2)');
        MakeTable('4.70.1215','Internet Explorer 3.01');
        MakeTable('4.70.1300','Internet Explorer 3.02 and 3.02a');
        MakeTable('4.71.1008.3','Internet Explorer 4.0 Platform Preview 2.0 (PP2)');
        MakeTable('4.71.1712.5','Internet Explorer 4.0');
        MakeTable('4.72.2106.7','Internet Explorer 4.01');
        MakeTable('4.72.3110.3','Internet Explorer 4.01 Service Pack 1 (Windows 98)');
        MakeTable('4.72.3612.1707','Internet Explorer 4.01 Service Pack 2');
        MakeTable('5.00.0518.5','Internet Explorer 5 Developer Preview (Beta 1)');
        MakeTable('5.00.0910.1308','Internet Explorer 5 Beta (Beta 2)');
        MakeTable('5.00.2014.213','Internet Explorer 5');
        MakeTable('5.00.2314.1000','Internet Explorer 5 (Office 2000)');
        MakeTable('5.00.2516.1900','Internet Explorer 5.01 (Windows 2000 Beta 3, build 5.00.2031)');
        MakeTable('5.00.2614.3500','Internet Explorer 5 (Windows 98 Second Edition)');
        MakeTable('5.00.2919.800','Internet Explorer 5.01 (Windows 2000 RC1, build 5.00.2072)');
        MakeTable('5.00.2919.3800','Internet Explorer 5.01 (Windows 2000 RC2, build 5.00.2128)');
        MakeTable('5.00.2919.6307','Internet Explorer 5.01 (Office 2000 SR-1)');
        MakeTable('5.00.2920.0000','Internet Explorer 5.01 (Windows 2000, build 5.00.2195)');
        MakeTable('5.00.3103.1000','Internet Explorer 5.01 SP1 (Windows 2000 SP1)');
        MakeTable('5.00.3105.0106','Internet Explorer 5.01 SP1 (Windows 95/98 and Windows NT 4.0)');
        MakeTable('5.00.3314.2100','Internet Explorer 5.01 SP2 (Windows 95/98 and Windows NT 4.0)');
        MakeTable('5.00.3315.2879','Internet Explorer 5.01 SP2 (Windows 2000 SP2)');
        MakeTable('5.00.3502.5400','Internet Explorer 5.01 SP3 (Windows 2000 SP3 only)');
        MakeTable('5.00.3700.6668','Internet Explorer 5.01 SP4 (Windows 2000 SP4 only)');
        MakeTable('5.50.3825.1300','Internet Explorer 5.5 Developer Preview (Beta)');
        MakeTable('5.50.4030.2400','Internet Explorer 5.5 & Internet Tools Beta');
        MakeTable('5.50.4134.0100','Internet Explorer 5.5 for Windows Me (4.90.3000)');
        MakeTable('5.50.4134.0600','Internet Explorer 5.5');
        MakeTable('5.50.4308.2900','Internet Explorer 5.5 Advanced Security Privacy Beta');
        MakeTable('5.50.4522.1800','Internet Explorer 5.5 Service Pack 1');
        MakeTable('5.50.4807.2300','Internet Explorer 5.5 Service Pack 2');
        MakeTable('6.00.2462.0000','Internet Explorer 6 Public Preview (Beta)');
        MakeTable('6.00.2479.0006','Internet Explorer 6 Public Preview (Beta) Refresh');
        MakeTable('6.00.2600.0000','Internet Explorer 6 (Windows XP)');
        MakeTable('6.00.2800.1106','Internet Explorer 6 Service Pack 1 (Windows XP SP1)');
        MakeTable('6.00.2800.1278','Internet Explorer 6 Update v.01 Developer Preview (SP1b Beta)');
        MakeTable('6.00.2800.1314','Internet Explorer 6 Update v.04 Developer Preview (SP1b Beta)');
        MakeTable('6.00.2900.2180','Internet Explorer 6 for Windows XP SP2');
        MakeTable('6.00.3663.0000','Internet Explorer 6 for Microsoft Windows Server 2003 RC1');
        MakeTable('6.00.3718.0000','Internet Explorer 6 for Windows Server 2003 RC2');
        MakeTable('6.00.3790.0000','Internet Explorer 6 for Windows Server 2003 (released)');

        //  o[WɈv̂邩ǂׂ
        index := DllVerTable.IndexOf(Result);
        if (index <> -1) then
        begin
            Result := Format('%s'#13#10'%s:%s', [ExeVerTable[index], IE_DLL, Result]);
        end
        //  Ȃꍇ́AR𒴂Ȃő̃o[Ŵ̗̂p
        else
        begin
            index := 0;
            for i := 0 to DllVerTable.Count - 1 do
            begin
                if (DllVerTable[i] > Result) then break;
                index := i;
            end;
            Result := Format('%s'#13#10'%s:%s', [ExeVerTable[index], IE_DLL, Result]);
        end;
    finally
        DllVerTable.Free;
        ExeVerTable.Free;
    end;
end;

//  ===========================================================================
//  IE̍XVe擾
//  ===========================================================================
function GetIEUpdate(): string;
const
    IE_KEY = 'SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings';
    MINOR_VERSION = 'MinorVersion';
var
    Reg: TRegistry;
begin
    Result := '';
    Reg := TRegistry.Create;
    try
        //  [gL[ݒ肵
        Reg.RootKey := HKEY_LOCAL_MACHINE;
        //  ǂ̃L[J(ȂꍇɍȂ悤)
        if Reg.OpenKeyReadOnly(IE_KEY) then
        begin
            Result := Reg.ReadString(MINOR_VERSION);
        end;
    finally
        Reg.Free;
    end;
end;

//  ===========================================================================
//  ʂ̕\\
//  http://homepage1.nifty.com/MADIA/delphi/Win32API/kaizoudo.htm
//  http://www.borland.co.jp/tips/delphi/dh008/
//  ===========================================================================
function GetScreenAbility(): string;
var
    DesktopWND: HWND;
    DesktopDC: HDC;
begin
    //  fXNgbṽfoCXReLXgnh擾
    DesktopWND := GetDesktopWindow;
    DesktopDC := GetDC(DesktopWND);
    //  ʔ\͂擾
    try
        Result := Format('%dpx(%dmm)~%dpx(%dmm) %dbits',[
            GetDeviceCaps(DesktopDC, HORZRES),
            GetDeviceCaps(DesktopDC, HORZSIZE),
            GetDeviceCaps(DesktopDC, VERTRES),
            GetDeviceCaps(DesktopDC, VERTSIZE),
            GetDeviceCaps(DesktopDC, BITSPIXEL)
        ]);
    finally
        ReleaseDC(DesktopWND, DesktopDC);
    end;
end;

//  ===========================================================================
//  ̏
//  http://hp.vector.co.jp/authors/VA009712/take/delphi/kabesys.htm#getmemory
//  http://forum.nifty.com/fdelphi/samples/01380.html
//  http://community.borland.com/article/0,1410,16582,00.html
//  ===========================================================================
function GetMemoryStatus(var Phys, Page, Virt: string): string;
var
    MemoryStatus: TMemoryStatus;
begin
    //  𓾂
    FillChar(MemoryStatus, SizeOf(MemoryStatus), 0);
    MemoryStatus.dwLength := SizeOf(TMemoryStatus);
    GlobalMemoryStatus(MemoryStatus);

    //  o
    with MemoryStatus do
    begin
        Phys := Format('S %s | gp %s |  %s',
                        [B2KB(dwTotalPhys),
                         B2KB(dwTotalPhys - dwAvailPhys),
                         B2KB(dwAvailPhys)]);
        Page := Format('S %s | gp %s |  %s',
                        [B2KB(dwTotalPageFile),
                         B2KB(dwTotalPageFile - dwAvailPageFile),
                         B2KB(dwAvailPageFile)]);
        Virt := Format('S %s | gp %s |  %s',
                        [B2KB(dwTotalVirtual),
                         B2KB(dwTotalVirtual - dwAvailVirtual),
                         B2KB(dwAvailVirtual)]);
    end;
end;

//  ===========================================================================
//  hCȕ
//  http://www.borland.co.jp/qanda/delphi/d0009389.html
//  http://homepage1.nifty.com/MADIA/delphi/Win32API/GetDrives.htm
//  http://forum.nifty.com/fdelphi/faq/00116.htm
//  http://www.borland.co.jp/qanda/delphi/d0002383.html
//  http://hp.vector.co.jp/authors/VA009712/take/delphi/kabesys.htm#gethdd
//  http://www.users.gr.jp/ml/archive/viewer.aspx?name=delphi&no=24099
//  ===========================================================================
function GetDriveStatus(): string;

    //  ---------------------------------------------
    //  VXehCu̎擾
    function GetSystemDrive(): char;
    var
        s: string;
    begin
        s := ExtractFileDrive(GetWindowsDirectory());
        if (s <> '') then Result := s[1] else Result := #0;
    end;

    //  ---------------------------------------------
    //  p\ȃhCu̗
    function AvailableDrives(): string;
    var
        ld: DWORD;
        i: integer;
    begin
        Result := '';
        ld := GetLogicalDrives;
        for i := 0 to 25 do
        begin
            if (ld and (1 shl i)) > 0 then Result := Result + (Char(Ord('A') + i));
        end;
    end;
    //  ---------------------------------------------
    //  fBXNhCu̎ނ擾
    function GetDriveType(Drive: Char): string;
    var
        DriveType: Byte;
    begin
        DriveType := Windows.GetDriveType(PChar(Drive + ':\'));
        case DriveType of
            DRIVE_REMOVABLE: Result := 'REMOVABLE     ';
            DRIVE_FIXED    : Result := 'HARDDISK      ';
            DRIVE_REMOTE   : Result := 'NETWORK_DRIVE ';
            DRIVE_CDROM    : Result := 'CD-ROM        ';
            DRIVE_RAMDISK  : Result := 'RAMDISK       ';
        end;
    end;
    //  ---------------------------------------------
    //  {[̎擾
    function GetVolumeName(Drive: Char): string;
    var
        shfi: TSHFileInfo;
    begin
        SHGetFileInfo(PChar(Drive + ':\'), 0, shfi, SizeOf(shfi), SHGFI_DISPLAYNAME);
        Result := shfi.szDisplayName;
    end;
    //  ---------------------------------------------
    //  hCuDiskFree/DiskSizeŎgpł鐔l\ɕϊ
    function DriveCharToByte(Drive: Char): Byte;
    const
        DRIVES = '#ABCDEFGHIJKLMNOPQRSTUVWXYZ';
    begin
        //JghCu=0AA=1AB=2AC=3A
        Result := Pos(UpCase(Drive), DRIVES) - 1;
    end;
    //  ---------------------------------------------
    //  wfBXN̑e(oCg)擾
    function GetDiskSize(Drive: Char): Int64;
    begin
        Result := DiskSize(DriveCharToByte(Drive));
    end;
    //  ---------------------------------------------
    //  wfBXN̋󂫗e(oCg)擾
    function GetDiskFree(Drive: Char): Int64;
    begin
        Result := DiskFree(DriveCharToByte(Drive));
    end;
    //  ---------------------------------------------
    //  t@CVXeȂ
    function GetFileSystem(Drive: Char): string;
    const
        BUF_SIZE = 260;
    var
        VolumeNameBuffer: array[0..BUF_SIZE-1] of char;
        VolumeSerialNumber: DWORD;
        MaximumComponentLength: DWORD;
        FileSystemFlags: DWORD;
        FileSystemNameBuffer: array[0..BUF_SIZE-1] of char;
    begin
        if (Trim(GetDriveType(Drive)) <> 'HARDDISK') then Result := ''
        else
        begin
            GetVolumeInformation(
                PChar(Drive + ':\'),
                VolumeNameBuffer, BUF_SIZE,
                @VolumeSerialNumber,
                MaximumComponentLength,
                FileSystemFlags,
                FileSystemNameBuffer, BUF_SIZE
            );
            Result := FileSystemNameBuffer;
        end;
    end;

var
    Mode: Word;
    Drives, Line: string;
    Drive, SysDrive, Check: char;
    i: integer;
    Total, Avail: Int64;
begin
    Mode := SetErrorMode(SEM_FAILCRITICALERRORS);
    Result := '';
    SysDrive := GetSystemDrive();
    Drives := AvailableDrives();
    for i := 1 to Length(Drives) do
    begin
        Drive := Drives[i];
        if (Drive = SysDrive) then Check := '*' else Check := ' ';
        Total := GetDiskSize(Drive);
        Avail := GetDiskFree(Drive);
        Line := Format('%s:\(%s) (%s) %s %s | S %s | gp %s |  %s',
                [Drive,
                 Check,
                 GetDriveType(Drive),
                 GetVolumeName(Drive),
                 GetFileSystem(Drive),
                 B2KB(Total),
                 B2KB(Total - Avail),
                 B2KB(Avail)
                ]);
        Result := Result + #13#10 + Line;
    end;
    Result := Trim(Result);
    SetErrorMode(Mode);
end;

end.

