unit util;

interface

uses
    Windows, SysUtils;

type
    TOSVersionInfoEx = record
        dwOSVersionInfoSize : DWORD;
        dwMajorVersion      : DWORD;
        dwMinorVersion      : DWORD;
        dwBuildNumber       : DWORD;
        dwPlatformId        : DWORD;
        szCSDVersion        : array[0..127] of AnsiChar;
        wServicePackMajor   : WORD;
        wServicePackMinor   : WORD;
        wSuiteMask          : WORD;
        wProductType        : BYTE;
        wReserved           : BYTE;
    end;

// Windows.pas
function GetVersionEx(var lpVersionInformation: TOSVersionInfoEx): BOOL; stdcall;
function GetVersionEx; external kernel32 name 'GetVersionExA';

function GetWindowsDirectory(): string;
function GetFileVersion(const FileName: string): string;

function B2KB(const inByte: Int64): string;

implementation

//  ===========================================================================
//  WindowsfBNg̎擾
//  ===========================================================================
function GetWindowsDirectory(): string;
var
    PBuf: PChar;
begin
    GetMem(PBuf, MAX_PATH + 1);
    Windows.GetWindowsDirectory(PBuf, MAX_PATH + 1);
    Result := PBuf;
    FreeMem(PBuf);
end;

//  ===========================================================================
//  t@Co[W̎擾
//  http://www2.big.or.jp/~osamu/Delphi/Tips/key.cgi?key=27#0226.txt
//  ===========================================================================
function GetFileVersion(const FileName: string): string;
const
    Translation = '\VarFileInfo\Translation';
    FileInfo = '\StringFileInfo\%0.4s%0.4s\';
var
    BufSize, HWnd: DWORD;
    VerInfoBuf: Pointer;
    VerData: Pointer;
    VerDataLen: Longword;
    PathLocale: String;
begin
    Result := '';
    // Kvȃobt@̃TCY擾
    BufSize := GetFileVersionInfoSize(PChar(FileName), HWnd);
    if BufSize <> 0 then
    begin
        // m
        GetMem(VerInfoBuf, BufSize);
        try
            GetFileVersionInfo(PChar(FileName), 0, BufSize, VerInfoBuf);
            // ϐubN̕ϊe[uw
            VerQueryValue(VerInfoBuf, PChar(Translation), VerData, VerDataLen);
            if (VerDataLen > 0) then
            begin
                // 816iɕϊ
                // '\StringFileInfo\027382\FileDescription'
                PathLocale := Format(FileInfo + 'FileVersion',
                [IntToHex(Integer(VerData^) and $FFFF, 4),
                IntToHex((Integer(VerData^) shr 16) and $FFFF, 4)]);
                VerQueryValue(VerInfoBuf, PChar(PathLocale), VerData, VerDataLen);
                if VerDataLen > 0 then
                begin
                    // VerData̓[ŏI镶ł͂ȂƂɒ
                    SetLength(result, VerDataLen);
                    StrLCopy(PChar(result), VerData, VerDataLen);
                end;
            end;
        finally
            // 
            FreeMem(VerInfoBuf);
        end;
    end;
end;

//  ===========================================================================
//  oCgLoCg
//  http://hp.vector.co.jp/authors/VA009712/take/delphi/kabesys.htm#getmemory
//  ===========================================================================
function B2KB(const inByte: Int64): string;
begin
    Result := FormatFloat('#,##0 KB', Round(inByte / 1024));
end;

end.

